#include "gagebar.h"

TGageBar::TGageBar(const TRect& bounds)
  :TParamText(bounds)
  {
  gageBuffer = new char[size.x+1];      // allocate some string space
  gageBuffer[size.x] = '\0';            // assign the null terminator;
  for(int j=0;j<size.x;j++)             // fill with blank chars
  gageBuffer[j] = BLANKCHAR;

  options |= ofFramed;                  // turn on the frame
  }

TGageBar::~TGageBar()
  {
  delete [] gageBuffer;                // delete the string
  }

void TGageBar::setParams(int aValue,int aMax)  // sets max gage value and inits
  {                                            // the value
  maxValue = aMax;
  setValue(aValue);
  }

void TGageBar::setValue(int aValue)
  {
  int charsToFill=0;
  currentValue = aValue;                     // store new value
  if(currentValue > maxValue)                // check that its within bounds
    currentValue = maxValue;
  if(currentValue < 0)
    currentValue = 0;

  for(int j=0;j<size.x;j++)                  // fill in all chars with blanks
    gageBuffer[j] = BLANKCHAR;
                                             // calculate # of full block chars
  charsToFill = (int) ((long)currentValue * size.x / maxValue);
  for(j=0;j<charsToFill;j++)                 // fill in the block chars
    gageBuffer[j] = FILLCHAR;
                                             // calc rounding for a half char
  if( ((long)currentValue * size.x*10 / maxValue - charsToFill*10) >= 5  )
    gageBuffer[j] = HALFCHAR ;

  TParamText::setText(gageBuffer);           // buffer is ready to display
  }                                          // use base class for this


int TGageBar::getValue(void)
  {
  return(currentValue);                      // return stored value.
  }

