#include "gagedlg.h"
#include <math.h>

TGageDlg::TGageDlg(const TRect& r,const char *str)
  :TDialog(r,str),
   TWindowInit(&TGageDlg::initFrame)
  {
  TWindow::flags &= ~wfClose;   // no close icon, prevents crashing via idle
  options |= ofCentered ;       // centers dialog
  degrees=0;                    // degrees is used in update, so init it
                                // add some text to see
  captionText     = new TStaticText(TRect(15,2,36,3),"Gage Readings");
  gage1Text       = new TStaticText(TRect(3,4,15,5),  "Gage #1");
  gage2Text       = new TStaticText(TRect(3,6,15,7),  "Gage #2");
  gage3Text       = new TStaticText(TRect(3,8,15,9),  "Gage #3");

    // construct some gage bars.
    // TGageBar::setParams(initial value, maximum value).
    // note that you talk to the gage bars in terms of value, not character
    // position, sort of like a scroll bar
  gageBar1 = new TGageBar(TRect(16,4,36,5));
  gageBar1->setParams(60,200);
  gageBar2 = new TGageBar(TRect(16,6,36,7));
  gageBar2->setParams(120,200);
  gageBar3= new TGageBar(TRect(16,8,36,9));
  gageBar3->setParams(180,200);

    // these just display values next to the gagebar.  This could all be rolled
    // into the gage bar itself, but I decided to keep them separate.  Note that
    // the gage bar will clip off values outside its specified range(<0 || >max)
  gage1Value=new TParamText(TRect(37,4,44,5));
  gage1Value->setText("%3d",60);
  gage2Value=new TParamText(TRect(37,6,44,7));
  gage2Value->setText("%3d",120);
  gage3Value=new TParamText(TRect(37,8,44,9));
  gage3Value->setText("%3d",180);
  }


void TGageDlg::insertResources(void)
  {
  // this just inserts each subview.
  this->insert(captionText);
  this->insert(gage1Text);
  this->insert(gage2Text);
  this->insert(gage3Text);

  this->insert(gageBar1);
  this->insert(gageBar2);
  this->insert(gageBar3);

  this->insert(gage1Value);
  this->insert(gage2Value);
  this->insert(gage3Value);
  }


// this is called by the main application classes idle function every timer tick
// The purpose here is to just give the gage bars some movement.
void TGageDlg::update(void)
  {
  int temp_value;

  temp_value = 100 + (int)100 * sin( (double) degrees/180*3.14159);
  gageBar1->setValue(temp_value);
 	gage1Value->setText("%3d",temp_value);

  temp_value = 100 + (int)100 * sin( (double) (degrees+120)/180*3.14159);
  gageBar2->setValue(temp_value);
 	gage2Value->setText("%3d",temp_value);

  temp_value = 100 + (int)100 * sin( (double) (degrees+240)/180*3.14159);
  gageBar3->setValue(temp_value);
 	gage3Value->setText("%3d",temp_value);

  degrees+=2;
  if(degrees > 360)
    degrees = 0;
  }






